package com.example;

@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2021-04-09T22:14:49.431Z")
@javax.ws.rs.Path("")
public interface TransactionsApi {

	@javax.ws.rs.POST
	@javax.ws.rs.Path("/transactions")
	@javax.ws.rs.Consumes({ "application/json" })
	@javax.ws.rs.Produces({ "application/json" })
	@io.swagger.v3.oas.annotations.Operation(
		summary = "Create a transaction",
		description = "Triggers an ID verification, either as an SMS we will send to your customers or as a link which you can pass on or redirect your customer to however you like.",
		responses = {
			@io.swagger.v3.oas.annotations.responses.ApiResponse(responseCode = "200", description = "OK"),
			@io.swagger.v3.oas.annotations.responses.ApiResponse(responseCode = "400", description = "The server could not understand the request due to invalid syntax."),
			@io.swagger.v3.oas.annotations.responses.ApiResponse(responseCode = "401", description = "Although the HTTP standard specifies \"unauthorized\", semantically this response means \"unauthenticated\". That is, the client must authenticate itself to get the requested response."),
			@io.swagger.v3.oas.annotations.responses.ApiResponse(responseCode = "500", description = "The server has encountered a situation it doesn't know how to handle.")
		},
		security = {
			@io.swagger.v3.oas.annotations.security.SecurityRequirement(name = "oAuth2ClientCredentials", scopes = { "transactions/post" }),
		},
		tags={ "transactions" }
	)
	javax.ws.rs.core.Response create(@io.swagger.v3.oas.annotations.Parameter(description = "Create Transaction Parameters", required = true) com.example.model.CreateRequest request);

	@javax.ws.rs.GET
	@javax.ws.rs.Path("/transactions/{transaction_id}/{format}")
	@javax.ws.rs.Produces({ "application/json" })
	@io.swagger.v3.oas.annotations.Operation(
		summary = "Fetch a transaction",
		description = "Get the transaction payload data by `trasanction_id`. You can generate a PDF (Base64 data) by setting the `format` to \"pdf\".",
		responses = {
			@io.swagger.v3.oas.annotations.responses.ApiResponse(responseCode = "200", description = "OK"),
			@io.swagger.v3.oas.annotations.responses.ApiResponse(responseCode = "400", description = "The server could not understand the request due to invalid syntax."),
			@io.swagger.v3.oas.annotations.responses.ApiResponse(responseCode = "401", description = "Although the HTTP standard specifies \"unauthorized\", semantically this response means \"unauthenticated\". That is, the client must authenticate itself to get the requested response."),
			@io.swagger.v3.oas.annotations.responses.ApiResponse(responseCode = "404", description = "Although the HTTP standard specifies \"unauthorized\", semantically this response means \"unauthenticated\". That is, the client must authenticate itself to get the requested response."),
			@io.swagger.v3.oas.annotations.responses.ApiResponse(responseCode = "500", description = "The server has encountered a situation it doesn't know how to handle.")
		},
		security = {
			@io.swagger.v3.oas.annotations.security.SecurityRequirement(name = "oAuth2ClientCredentials", scopes = { "transactions/get" }),
		},
		tags={ "transactions" }
	)
	javax.ws.rs.core.Response get(@io.swagger.v3.oas.annotations.Parameter(name = "transaction_id", description = "Transaction ID", required = true) @javax.ws.rs.PathParam("transaction_id") java.lang.String transaction_id, @io.swagger.v3.oas.annotations.Parameter(name = "format", description = "Available values are: json, pdf", required = true) @javax.ws.rs.PathParam("format") java.lang.String format);

}
